/*
Versione OK su C68 v4.14
*/

char _prog_name[] = "LSPIC";


#include <stdio.h>
#include <stdlib.h>
#include <string.h>            /* Aggiungere nei files questo include  */

void fatal(s)
char * s;
{
        fprintf (stderr,"ERROR: %s\n",s);
        exit(1);
}

void usage()
{
                printf ("use: LSPIC file [[file]...]\n\n");
                printf ("This program accept GIF and IFF files\n\n");
                printf ("(c)1991 by Giuseppe Zanetti, via Vergani,11 - 35031 Abano T. (Padova)\n");
                printf ("                                              ITALIA\n\n");
                printf ("E-mail: beppe@alessia.dei.unipd.it\n\n");

                exit (1);
}


void checkgif(filename)
char *filename;
{
        FILE * infile;
        unsigned char buf[255];
        char ch;
        unsigned char map[256][3];
        int globalbits,localbits;

        globalbits=0;
        localbits=0;


        printf ("File Name:    %s\n",filename);

        infile = fopen(filename,"r");

        if (!infile) fatal("error opening file");

        fread(buf,1,6,infile);

        if (strncmp(buf,"GIF",3)) fatal("file is not a GIF file");

        if (strncmp(&buf[3],"87a",3)) fatal("unknown GIF version number");

        printf ("File Type:    GIF87a\n");

        fread(buf,1,7,infile);

        printf ("Screenwidth:  %d\n",(buf[0] + (buf[1] << 8)));
        printf ("Screenheight: %d\n",(buf[2] + (buf[3] << 8)));


        if (buf[4] & 0x80)
        {
            globalbits = (buf[4] & 0x07) + 1;

            printf ("Glob. Colors: %d\n",1 << globalbits);
            
            fread(map,3,1<<globalbits,infile);

        }



        ch = getc(infile);

        if (ch == ',')
        {
                fread(buf,1,9,infile);

                printf("Orig. left:   %d\n",(buf[0] + (buf[1] << 8)));
                printf("Orig. top:    %d\n",(buf[2] + (buf[3] << 8)));
                printf("Image width:  %d\n",(buf[4] + (buf[5] << 8)));
                printf("Image height: %d\n",(buf[6] + (buf[7] << 8)));
                printf("Interlaced:   %s\n",(buf[8] & 0x40)?"yes":"no");

                if (buf[8] & 0x80)
                {
                        localbits = (buf[8] & 0x7) + 1;
                        printf ("Local Colors: %d\n",1 << localbits);
                        fread(map,3,1<<localbits,infile);
                }

        }
        else
        {
                fatal("illegal GIF block type");
        }


        if ((!localbits) && (!globalbits))
        {
                printf("WARNING:      Color-Map not present\n");
        }

        fclose (infile);
}


void checklbm(filename)
char *filename;
{
        FILE * infile;
        unsigned char buf[255];


        printf ("File Name:    %s\n",filename);

        infile = fopen(filename,"r");

        if (!infile) fatal("error opening file");

        fread(buf,1,4,infile);
        if (strncmp(buf,"FORM",4)) fatal("file is not a IFF file");

        fread(buf,1,4,infile);
        fread(buf,1,4,infile);
        if (strncmp(buf,"ILBM",4)) fatal("This is a IFF file but not a image");

        printf ("File Type:    Amiga IFF-LBM\n");

        fread(buf,1,4,infile);
        if (strncmp(buf,"BMHD",4)) fatal("Information table is not present");

        fread(buf,1,4,infile);

        fread(buf,1,4,infile);
        printf("Image width:  %d\n",(buf[1] + (buf[0] << 8)));
        printf("Image height: %d\n",(buf[3] + (buf[2] << 8)));

        fread(buf,1,4,infile);
        fread(buf,1,1,infile);
        printf("Colors:       %d\n",1 << buf[0]);

        fread(buf,1,1,infile);
        fread(buf,1,1,infile);
        printf("Compressed:   %s\n",buf[0]?"yes":"no");

        fclose(infile);
}




main(argc,argv)
int argc;
char *argv[];
{
        int loop;
        char extension[255];

        if (argc == 1) usage();

        for (loop=1;loop<argc;loop++)
        {
                strcpy(extension,argv[loop]+strlen(argv[loop])-3);

                if ((!strcmp(extension,"gif")) || (!strcmp(extension,"GIF")))
                {
                        checkgif(argv[loop]);
                }

                if ((!strcmp(extension,"iff")) || (!strcmp(extension,"IFF")))
                {
                        checklbm(argv[loop]);
                }

                if ((!strcmp(extension,"lbm")) || (!strcmp(extension,"LBM")))
                {
                        checklbm(argv[loop]);
                }


                printf("\n");
        }

        return(0);
}
