/*
Versione OK su C68 v4.14
*/

char _prog_name[] = "QIFF";



#include <stdio.h>
#include <stdlib.h>
#include "plot.h"
#include <string.h>            /* Aggiungere nei files questo include  */
#include <unistd.h>
#include <fcntl.h>

/* defines and new types */

typedef unsigned char  ubyte;
typedef unsigned short uword;
typedef unsigned long  ulong;
typedef ubyte          flag;

#define BUFLEN 128
#define MAXBYTE 128
#define MAXPLAN 6

#define GRAY 0x01

#ifndef TRUE
#define TRUE 1
#define FALSE 0
#endif

int fi = -1 ;

/* functions */

help_func(n)
int n;
{
          switch(n)
          {
                    case 0:
                              break;
                    case 1:
                              fprintf(stderr,"Not file in input ....\n");
                              break;
                    case 2:
                              fprintf(stderr,"I can't open file please retry ...\n");
                              break;
                    case 3:
                              fprintf(stderr,"This is not a IFF file please retry\n");
                              break;
                    case 4:
                              fprintf(stderr,"This is a IFF file but is not a image file ... \n");
                              break;
                    case 5:
                              fprintf(stderr,"I can't find information about this image ?!!\n");
                              break;
                    case 6:
                              fprintf(stderr,"Not available memory sorry ...\n");
                              break;
                    case 7:
                              fprintf(stderr,"Too big value of contrast !\n");
                              break;
                    case 8:
                              fprintf(stderr,"Unrecognized switch in command line !\n");
                              break;
                    default:
                              fprintf(stderr,"hemm why don't ? I think a bug !\n");
                              break;
          }

          if (fi!=-1) close(fi);

          return(n==0);
}

/* i^n = i*i*i*i*i*...*i n times */

ubyte pot(i,n)
ubyte i,n;
{
          ubyte p=1;
          for(;n>0;--n) p*=i;
          return(p);
}

ConvImage(name1,beg,sat,mode,cont)
char name1[];
ubyte beg,sat,cont;
flag mode;
{
          ulong pos,dim,max;
          uword tmp,rig,width,height,i;
          ubyte co,col,bl,bgl,bdl,j,pia,depth;
          ubyte ncolors,r,g,b,bit,bcol,sh,lcount,pix;
          ubyte buf[BUFLEN],row[MAXPLAN][MAXBYTE],lum[64],bmp[MAXBYTE];
          ubyte hb,lb;
          int xplot,yplot;

          xplot=0;
          yplot=0;

        cls();

        sat=(sat*45)/100;
        beg=(beg*45)/100;
        max=pot(cont,15);
        
        if (!strcmp(name1,"")) return(help_func(1));
        fi=open(name1,0);

        if (fi==-1) return(help_func(2));

        read(fi,buf,4);
        buf[4]=0;
        if (strcmp(buf,"FORM")) return(help_func(3));
        read(fi,buf,4);                 /* size of file (not used) */
        read(fi,buf,4);                 /* type of file (ILBM is a image)*/
        buf[4]=0;                       /* Interlaved Bitmap */
        if (strcmp(buf,"ILBM")) return(help_func(4));
        read(fi,buf,4);                 /* information about image (BHMD) */
        buf[4]=0;
        if (strcmp(buf,"BMHD")) return(help_func(5));
        read(fi,buf,4);                 /* size of all information (I don't use) */

        read(fi,&hb,1);         /* width  2 byte */
        read(fi,&lb,1);

        width=hb*255+lb;

        read(fi,&hb,1);         /* height 1 byte */
        read(fi,&lb,1);

        height=hb*255+lb;

        read(fi,buf,4);                 /* ??!! I dont' know */
        read(fi,&depth,1);              /* number of bit-palnes */
        ncolors=1<<depth;
        read(fi,&tmp,1);
        read(fi,&co,1);                 /* is compressed ? (0 No!, 1 Yes!) */
        pos=lseek(fi,0,1);
        while(read(fi,buf,4))
        {
                buf[4]=0;

                if (strcmp(buf,"CMAP")==0)
                {
                        read(fi,&dim,4);
                        read(fi,buf,dim);
                        for (i=0;i<ncolors;++i)
                        {
                                if(i<32)
                                {
                                        r=(buf[i*3+0])/16;
                                        g=(buf[i*3+1])/16;
                                        b=(buf[i*3+2])/16;
                                }
                                else
                                {
                                        r=(buf[(i-32)*3+0])/32;
                                        g=(buf[(i-32)*3+1])/32;
                                        b=(buf[(i-32)*3+2])/32;
                                }
                                if (cont==0) lum[i]=(r+g+b);
                                else lum[i]=(pot(cont,(r+g+b)/3)*45/max);

          if (mode == GRAY)
          {
                    lum[i]=(r+g+b)/6;
          }
                        }
                }
                if (strcmp(buf,"BODY")==0)
                {
                        read(fi,&dim,4);
                        col=((width+7)/8);
                        
                        for(rig=0;rig<height;++rig)
                        {
                                for(pia=0;pia<depth;++pia)
                                if (co)
                                {
                                        bgl=0;
                                        while(bgl<col)
                                        {
                                                read(fi,&bdl,1);
                                                if (bdl<128)
                                                {
                                                        read(fi,&row[pia][bgl],bdl+1);
                                                        bgl=bgl+bdl+1;
                                                }
                                                else if(bdl>128)
                                                {
                                                        read(fi,&bl,1);
                                                        for(j=0;j<257-bdl;++j)
                                                        row[pia][bgl+j]=bl;
                                                        bgl=bgl+257-bdl;
                                                }
                                        }
                                }
                                else read(fi,&row[pia][0],col);
                                lcount=beg;
                                for(i=0;i<col;++i) bmp[i]=0;
                                for(i=0;i<width;++i)
                                {
                                        bcol=0;
                                        sh=7-(i%8);
                                        bit=(1<<sh);
                                        for(pia=0;pia<depth;++pia)
                                        bcol|=(1<<pia)*((bit&row[pia][i/8])>>sh);
                                        lcount+=lum[bcol];

     if (mode != GRAY)
     {
          if(lcount>sat)
          {
                    pix=1;
                    lcount-=sat;

                    plot(xplot,yplot,7);
          }
          else pix=0;
     }
     else
     {
          plot(xplot,yplot,lum[bcol]);
     }

                                        xplot++;
                                        if (xplot > width-1)
                                        {
                                                xplot=0;
                                                yplot++;
                                        }
                                }
                        }
  semexit(0);
                }
                pos++;
                lseek(fi,pos,0);
        }
        close(fi);
        return(TRUE);
}

main(argc,argv)
int argc;
char *argv[];
{
          char Infile[31];
          ubyte sat=100,start=50,cont=0,i;
          flag type=NULL;

          strcpy(Infile,"");

          for (i=1;i<argc;i++)
          {
                    if (argv[i][0]=='-')
                              switch(argv[i][1])
                              {
                              case 'B': strcpy(protez,argv[i]);
                                        break;
                              case 'g':
                                        type=GRAY;
                                        break;
                              case 'S':
                                        mysemap=(unsigned char *) atol(argv[i]+2); break;
                              case 'x': plotx0=atoi(argv[i]+2); break;
                              case 'y': ploty0=atoi(argv[i]+2); break;
                              default:
                                        help_func(8);
                                        semexit(-1);
                              }
                    else strcpy(Infile,argv[i]);
          }

          ConvImage(Infile,start,sat,type,cont);

          semexit(0);
}
