/*
Versione OK su C68 v4.14
*/

#include <stdio.h>
#include <stdlib.h>
#include "plot.h"
#include <string.h>            /* Aggiungere nei files questo include  */

#define NULLF (FILE *) 0


/* Read one tiff raster line */


void read_line(f,y,lx)
FILE *f;
int y;
int lx;
{
          int x,bit;
/*          char p;             cambiato */
          short p;
/*          unsigned char mask;         */
          short mask;

          for (x=0;x<lx;x+=8)
          {
                    p=fgetc(f);
                    mask=128;

                    for (bit=0;bit<8;bit++)
                    {
                              if (p & mask)
                              {
                                        plot(x+bit,y,7);
                              }

                              mask = mask >> 1;
                    }
          }
}



/* Main loop */
void load_tif_file(s)
char *s;
{
        int nentry,entry,raster;
        int tag;
        unsigned char temp1,temp2,temp3,temp4;
        unsigned int length,width,samples;
        unsigned long int value,offset;
        FILE *f;


/* file opening and tiff-header reading */


  if ((f = fopen(s, "rb")) == NULLF)
  {
        fprintf(stderr, "Cannot open input file.\n");
        semexit(-1);
  }


  fseek(f,4,SEEK_SET);          /* Skip alligment field & version */
        fread(&temp1,1,1,f);
        fread(&temp2,1,1,f);
        fread(&temp3,1,1,f);
        fread(&temp4,1,1,f);
        fseek(f,(temp1+256*temp2+65535*(temp3+256*temp4)),SEEK_SET);
/*  fseek(f,(fgetc(f)+256*fgetc(f))+65535*(fgetc(f)+256*fgetc(f)),SEEK_SET); */


        fread(&temp1,1,1,f);
        fread(&temp2,1,1,f);
        nentry=temp1+256*temp2;

/*  nentry=fgetc(f)+256*fgetc(f);       */

  for(entry=0;entry<nentry;entry++)
  {
        fread(&temp1,1,1,f);
        fread(&temp2,1,1,f);
        tag=temp1+256*temp2;
/*        tag=fgetc(f)+256*fgetc(f); cambiato */
        fseek (f,6,SEEK_CUR);           /* skip field type & count */

        fread(&temp1,1,1,f);
        fread(&temp2,1,1,f);
        fread(&temp3,1,1,f);
        fread(&temp4,1,1,f);
        value=(temp1+256*temp2+65535*(temp3+256*temp4));

        switch(tag)
        {
                case 256 :      {
                                        width=value;
                                        break;
                                }
                case 257 :      {
                                        length=value;
                                        break;
                                }
                case 273 :      {
                                        offset=value;
                                        break;
                                }
                case 277 :      {
                                        samples=value;
                                        break;
                                }
        }
  }

  if (samples != 1)
        { fprintf(stderr,"\nERROR: Only Monochrome Images !!!\n\n");
          fclose(f);
          semexit (-1);
        }

 cls();

 fseek(f,offset,SEEK_SET);      /* go to file data beginning */




 for (raster=0;raster<length;raster++)
        {
                read_line(f,raster,width);
        }

/* close files */

  fclose(f);
}

char _prog_name[] = "QTIF";


main(argc,argv)
int argc;
char *argv[];
{
          int i;


          if (argc<1)
          {
                    fprintf(stderr,"bad parameters in command line\n");
                    semexit (-1);
          }

          for (i=1;i<argc;i++)
          {
                   if (argv[i][0]=='-')
                              switch(argv[i][1])
                              {
                                        case 'B': strcpy(protez,argv[i]); break;
                                        case 'S':
                                                  mysemap=(unsigned char *) atol(argv[i]+2); break;
                                        case 'x': plotx0=atoi(argv[i]+2); break;
                                        case 'y': ploty0=atoi(argv[i]+2); break;
                                        default:
                                                  fprintf(stderr,"bad argument in command line\n");
                                                  semexit(-1);
                                                  break;
                              }
          }

                    load_tif_file(argv[1]);
                    semexit(0);
}
